﻿Imports MindFusion.UI.WinForms

Public Class Form1

    Private titleItem As DockItem
    Private imageItem As DockItem
    Private ingredientsItem As DockItem
    Private preparationItem As DockItem
    Private recipesListView As ListView
    Private recipes As List(Of Recipe)
    Private selectedRecipe As Recipe
    Private tb As TextBox
    Private grid As DataGridView
    Private pictureBox As PictureBox

    Public Sub New()
        InitializeComponent()

        recipes = New List(Of Recipe)(3)

        Dim flour As New Ingredient("flour", "../../images/flour.png")
        Dim sugar As New Ingredient("sugar", "../../images/sugar.png")
        Dim baking_powder As New Ingredient("baking powder", "../../images/baking_powder.png")
        Dim baking_soda As New Ingredient("baking soda", "../../images/baking_soda.png")
        Dim cocoa As New Ingredient("cocoa", "../../images/cocoa.png")
        Dim egg As New Ingredient("egg", "../../images/egg.png")
        Dim vanilla As New Ingredient("vanilla", "../../images/vanilla.png")
        Dim milk As New Ingredient("milk", "../../images/milk.png")
        Dim ginger As New Ingredient("ginger", "../../images/ginger.png")
        Dim butter As New Ingredient("butter", "../../images/butter.png")


        Dim chocolateCake As New Recipe("Chocolate Cake")
        chocolateCake.ImageUrl = "../../images/chocolate_cake.jpg"
        chocolateCake.IconUrl = "../../images/cake_icon.png"
        flour.Quantity = "3/4 cup"
        sugar.Quantity = "1 cup"
        cocoa.Quantity = "1 teaspoon"
        baking_powder.Quantity = "1 teaspoon"
        baking_soda.Quantity = "1/2 teaspoon"
        milk.Quantity = "1 cup"
        vanilla.Quantity = "1 small packet"
        egg.Quantity = "2"

        Dim cakeIngredients As New List(Of Ingredient)() From { _
         flour, _
         sugar, _
         egg, _
         cocoa, _
         baking_powder, _
         baking_soda, _
         vanilla, _
         milk _
        }
        chocolateCake.Ingredients = cakeIngredients
        chocolateCake.Preparation = "Mix the sugar, flour, cocoa, baking powder, baking soda in a large bowl. Add the eggs, the milk" & " and the vanilla. Beat with a mixer until texture is smooth. Pour the mixture into a greasy pan. Bake 30 to 35 minutes " & " until a wooden stick inserted in the center comes out clean. Do not open the oven the first 30 minutes to check!"

        recipes.Add(chocolateCake)
        selectedRecipe = chocolateCake

        Dim cupcakes As New Recipe("Cupcakes")
        cupcakes.ImageUrl = "../../images/cupcakes.jpg"
        cupcakes.IconUrl = "../../images/cupcake_icon.png"
        flour.Quantity = "2 cups"
        sugar.Quantity = "2 cups"
        baking_soda.Quantity = "2 teaspoons"
        vanilla.Quantity = "2 teaspoons"
        ginger.Quantity = "1/3 cup finely chopped"
        egg.Quantity = "4"
        butter.Quantity = "1 cup"

        Dim cupcakeIngredients As New List(Of Ingredient)() From { _
         flour, _
         sugar, _
         egg, _
         ginger, _
         baking_soda, _
         vanilla, _
         butter _
        }
        cupcakes.Ingredients = cupcakeIngredients
        cupcakes.Preparation = "Mix together the flour, the baking soda and the ginger in a deep bowl. " & "Beat the butter with the sugar using a mixer until sugar is dissolved. Add the eggs one at a time, stir manually. Add the butter " & " bit by bit. Finally beat in the vanilla dissolved with the last egg. Stir in the flour mixture and mix until smooth. " & "Pour the batter into the prepared muffin cups. Bake in a preheated oven at 350 degrees F (175 degrees C) for about 20 minutes."

        recipes.Add(cupcakes)

        Dim cookies As New Recipe("Cookies")
        cookies.ImageUrl = "../../images/cookies.jpg"
        cookies.IconUrl = "../../images/cookies_icon.png"
        flour.Quantity = "2 3/4 cups"
        sugar.Quantity = "2 cups"
        baking_soda.Quantity = "1 teaspoon"
        vanilla.Quantity = "2 teaspoons"
        egg.Quantity = "2"
        butter.Quantity = "1 1/4 cup"

        Dim cookiesIngredients As New List(Of Ingredient)() From { _
         flour, _
         sugar, _
         egg, _
         baking_soda, _
         vanilla, _
         butter _
        }
        cookies.Ingredients = cookiesIngredients
        cookies.Preparation = " Stir together the flour and the baking soda. Set aside. Beat together the butter and the sugar until light " & "and fluffy. Beat in the eggs one at a time, then the vanilla. Gradually add the dry ingredients, stir by hand until blended. " & " Spread the dough and cut circles with en empty glass or a cookie form. Place the cookies slightly apart. " & "Bake in a preheated oven at 350 degrees F (175 degrees C) for about 8-10 minutes."

        recipes.Add(cookies)

        titleItem = New DockItem() With { _
         .Header = "Recipe Name", _
         .Id = "Name" _
        }
       
        titleItem.DockStyle = DockStyle.Left
        titleItem.Content = GetContent("Name")

        imageItem = New DockItem() With { _
         .Header = "Recipe Image", _
         .Id = "Image" _
        }
        imageItem.DockStyle = DockStyle.Fill
        imageItem.Content = GetContent("Image")

        ingredientsItem = New DockItem() With { _
         .Header = "Ingredients", _
         .Id = "Ingredients" _
        }
        ingredientsItem.DockStyle = DockStyle.Bottom
        ingredientsItem.Content = GetContent("Ingredients")

        preparationItem = New DockItem() With { _
         .Header = "Preparation", _
         .Id = "Preparation" _
        }
        preparationItem.DockStyle = DockStyle.Right
        preparationItem.Content = GetContent("Preparation")

        DockControl1.Items.Add(titleItem)
        DockControl1.Items.Add(imageItem)
        DockControl1.Items.Add(ingredientsItem)

        DockControl1.Items.Add(preparationItem)
    End Sub

    Private Function GetContent(contentType As String) As Control
        Dim control As Control = Nothing
        If contentType = "Name" Then
            ' Create a new ListView control.
            recipesListView = New ListView()
            recipesListView.HideSelection = False
            recipesListView.MultiSelect = False
            recipesListView.BackColor = Color.FromArgb(245, 245, 245)

            ' Create two ImageList objects.
            Dim imageListSmall As New ImageList()
            Dim imageListLarge As New ImageList()

            'Assign the ImageList objects to the ListView.
            recipesListView.LargeImageList = imageListLarge
            recipesListView.SmallImageList = imageListSmall

            ' Set the view to show details.
            recipesListView.View = View.List
            ' Create three items and three sets of subitems for each item.
            Dim counter As Integer = 0

            For Each r As Recipe In recipes
                imageListLarge.Images.Add(Bitmap.FromFile(r.IconUrl))
                imageListSmall.Images.Add(Bitmap.FromFile(r.IconUrl))
                Dim item As New ListViewItem(r.Title, counter)
                recipesListView.Items.Add(item)
                counter += 1
            Next

            AddHandler recipesListView.SelectedIndexChanged, AddressOf recipesListView_SelectedIndexChanged

            control = recipesListView
        ElseIf contentType = "Ingredients" Then
            grid = New DataGridView()
            grid.DefaultCellStyle.BackColor = Color.FromArgb(247, 226, 189)
            grid.Dock = DockStyle.Fill
            grid.MultiSelect = False
            grid.DataSource = selectedRecipe.Ingredients
            grid.RowTemplate.MinimumHeight = 35

            grid.RowHeadersWidthSizeMode = DataGridViewRowHeadersWidthSizeMode.DisableResizing
            grid.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing
            grid.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
            grid.SelectionMode = DataGridViewSelectionMode.FullRowSelect
            grid.BackgroundColor = Color.FromArgb(253, 244, 247)

            control = grid
        ElseIf contentType = "Image" Then
            pictureBox = New PictureBox()

            ' Stretches the image to fit the pictureBox.
            pictureBox.SizeMode = PictureBoxSizeMode.Zoom
            pictureBox.BackColor = Color.FromArgb(251, 232, 240)
            pictureBox.ClientSize = imageItem.Size
            pictureBox.Image = Image.FromFile(selectedRecipe.ImageUrl)

            control = pictureBox

        ElseIf contentType = "Preparation" Then

            tb = New TextBox()
            tb.BackColor = Color.FromArgb(235, 255, 236)
            tb.Multiline = True
            tb.WordWrap = True
            tb.Text = selectedRecipe.Preparation
            tb.Margin = New System.Windows.Forms.Padding(5)


            control = tb
        End If

        Return control
    End Function

    Private Sub recipesListView_SelectedIndexChanged(sender As Object, e As EventArgs)
        If recipesListView.SelectedIndices.Count > 0 Then
            selectedRecipe = recipes(recipesListView.SelectedIndices(0))
            tb.Text = selectedRecipe.Preparation
            grid.DataSource = selectedRecipe.Ingredients
            pictureBox.Image = Image.FromFile(selectedRecipe.ImageUrl)
        End If

    End Sub

End Class
